#ifndef _H_509717AFC098BD5D9183AB89FF08AB72_Command_DCPS_H_
#define _H_509717AFC098BD5D9183AB89FF08AB72_Command_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Command_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Command_TypeSupportInterface;

            typedef Command_TypeSupportInterface * Command_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Command_TypeSupportInterface> Command_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Command_TypeSupportInterface> Command_TypeSupportInterface_out;


            class Command_DataWriter;

            typedef Command_DataWriter * Command_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Command_DataWriter> Command_DataWriter_var;
            typedef DDS_DCPSInterface_out < Command_DataWriter> Command_DataWriter_out;


            class Command_DataReader;

            typedef Command_DataReader * Command_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Command_DataReader> Command_DataReader_var;
            typedef DDS_DCPSInterface_out < Command_DataReader> Command_DataReader_out;


            class Command_DataReaderView;

            typedef Command_DataReaderView * Command_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Command_DataReaderView> Command_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Command_DataReaderView> Command_DataReaderView_out;

            struct Command_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Command_, struct Command_Seq_uniq_> Command_Seq;
            typedef DDS_DCPSSequence_var < Command_Seq> Command_Seq_var;
            typedef DDS_DCPSSequence_out < Command_Seq> Command_Seq_out;

            class  Command_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Command_TypeSupportInterface_ptr _ptr_type;
                typedef Command_TypeSupportInterface_var _var_type;

                static Command_TypeSupportInterface_ptr _duplicate (Command_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Command_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Command_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Command_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Command_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Command_TypeSupportInterface () {};
                ~Command_TypeSupportInterface () {};
            private:
                Command_TypeSupportInterface (const Command_TypeSupportInterface &);
                Command_TypeSupportInterface & operator = (const Command_TypeSupportInterface &);
            };

            class  Command_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Command_DataWriter_ptr _ptr_type;
                typedef Command_DataWriter_var _var_type;

                static Command_DataWriter_ptr _duplicate (Command_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Command_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Command_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Command_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Command_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Command_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Command_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Command_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Command_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Command_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Command_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Command_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Command_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Command_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Command_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Command_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Command_& instance_data) = 0;

            protected:
                Command_DataWriter () {};
                ~Command_DataWriter () {};
            private:
                Command_DataWriter (const Command_DataWriter &);
                Command_DataWriter & operator = (const Command_DataWriter &);
            };

            class  Command_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Command_DataReader_ptr _ptr_type;
                typedef Command_DataReader_var _var_type;

                static Command_DataReader_ptr _duplicate (Command_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Command_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Command_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Command_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Command_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Command_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Command_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Command_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Command_& instance) = 0;

            protected:
                Command_DataReader () {};
                ~Command_DataReader () {};
            private:
                Command_DataReader (const Command_DataReader &);
                Command_DataReader & operator = (const Command_DataReader &);
            };

            class  Command_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Command_DataReaderView_ptr _ptr_type;
                typedef Command_DataReaderView_var _var_type;

                static Command_DataReaderView_ptr _duplicate (Command_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Command_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Command_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Command_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Command_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Command_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Command_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Command_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Command_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Command_& instance) = 0;

            protected:
                Command_DataReaderView () {};
                ~Command_DataReaderView () {};
            private:
                Command_DataReaderView (const Command_DataReaderView &);
                Command_DataReaderView & operator = (const Command_DataReaderView &);
            };
        }

    }

}

#endif
