#ifndef _H_95F24B6507C8E318327A1432EDE96D3E_GridMap_DCPS_H_
#define _H_95F24B6507C8E318327A1432EDE96D3E_GridMap_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GridMap_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GridMap_TypeSupportInterface;

            typedef GridMap_TypeSupportInterface * GridMap_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GridMap_TypeSupportInterface> GridMap_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GridMap_TypeSupportInterface> GridMap_TypeSupportInterface_out;


            class GridMap_DataWriter;

            typedef GridMap_DataWriter * GridMap_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GridMap_DataWriter> GridMap_DataWriter_var;
            typedef DDS_DCPSInterface_out < GridMap_DataWriter> GridMap_DataWriter_out;


            class GridMap_DataReader;

            typedef GridMap_DataReader * GridMap_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GridMap_DataReader> GridMap_DataReader_var;
            typedef DDS_DCPSInterface_out < GridMap_DataReader> GridMap_DataReader_out;


            class GridMap_DataReaderView;

            typedef GridMap_DataReaderView * GridMap_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GridMap_DataReaderView> GridMap_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GridMap_DataReaderView> GridMap_DataReaderView_out;

            struct GridMap_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GridMap_, struct GridMap_Seq_uniq_> GridMap_Seq;
            typedef DDS_DCPSSequence_var < GridMap_Seq> GridMap_Seq_var;
            typedef DDS_DCPSSequence_out < GridMap_Seq> GridMap_Seq_out;

            class  GridMap_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GridMap_TypeSupportInterface_ptr _ptr_type;
                typedef GridMap_TypeSupportInterface_var _var_type;

                static GridMap_TypeSupportInterface_ptr _duplicate (GridMap_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GridMap_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GridMap_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GridMap_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GridMap_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GridMap_TypeSupportInterface () {};
                ~GridMap_TypeSupportInterface () {};
            private:
                GridMap_TypeSupportInterface (const GridMap_TypeSupportInterface &);
                GridMap_TypeSupportInterface & operator = (const GridMap_TypeSupportInterface &);
            };

            class  GridMap_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GridMap_DataWriter_ptr _ptr_type;
                typedef GridMap_DataWriter_var _var_type;

                static GridMap_DataWriter_ptr _duplicate (GridMap_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GridMap_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GridMap_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GridMap_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GridMap_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GridMap_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GridMap_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GridMap_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GridMap_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GridMap_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GridMap_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GridMap_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GridMap_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GridMap_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GridMap_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GridMap_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GridMap_& instance_data) = 0;

            protected:
                GridMap_DataWriter () {};
                ~GridMap_DataWriter () {};
            private:
                GridMap_DataWriter (const GridMap_DataWriter &);
                GridMap_DataWriter & operator = (const GridMap_DataWriter &);
            };

            class  GridMap_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GridMap_DataReader_ptr _ptr_type;
                typedef GridMap_DataReader_var _var_type;

                static GridMap_DataReader_ptr _duplicate (GridMap_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GridMap_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GridMap_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GridMap_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GridMap_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GridMap_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GridMap_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GridMap_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GridMap_& instance) = 0;

            protected:
                GridMap_DataReader () {};
                ~GridMap_DataReader () {};
            private:
                GridMap_DataReader (const GridMap_DataReader &);
                GridMap_DataReader & operator = (const GridMap_DataReader &);
            };

            class  GridMap_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GridMap_DataReaderView_ptr _ptr_type;
                typedef GridMap_DataReaderView_var _var_type;

                static GridMap_DataReaderView_ptr _duplicate (GridMap_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GridMap_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GridMap_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GridMap_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GridMap_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GridMap_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GridMap_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GridMap_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GridMap_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GridMap_& instance) = 0;

            protected:
                GridMap_DataReaderView () {};
                ~GridMap_DataReaderView () {};
            private:
                GridMap_DataReaderView (const GridMap_DataReaderView &);
                GridMap_DataReaderView & operator = (const GridMap_DataReaderView &);
            };
        }

    }

}

#endif
