#ifndef _H_5ABCF8AB74919D0235C18F87FC720FF9_Obstacle_DCPS_H_
#define _H_5ABCF8AB74919D0235C18F87FC720FF9_Obstacle_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Obstacle_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Obstacle_TypeSupportInterface;

            typedef Obstacle_TypeSupportInterface * Obstacle_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Obstacle_TypeSupportInterface> Obstacle_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Obstacle_TypeSupportInterface> Obstacle_TypeSupportInterface_out;


            class Obstacle_DataWriter;

            typedef Obstacle_DataWriter * Obstacle_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Obstacle_DataWriter> Obstacle_DataWriter_var;
            typedef DDS_DCPSInterface_out < Obstacle_DataWriter> Obstacle_DataWriter_out;


            class Obstacle_DataReader;

            typedef Obstacle_DataReader * Obstacle_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Obstacle_DataReader> Obstacle_DataReader_var;
            typedef DDS_DCPSInterface_out < Obstacle_DataReader> Obstacle_DataReader_out;


            class Obstacle_DataReaderView;

            typedef Obstacle_DataReaderView * Obstacle_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Obstacle_DataReaderView> Obstacle_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Obstacle_DataReaderView> Obstacle_DataReaderView_out;

            struct Obstacle_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Obstacle_, struct Obstacle_Seq_uniq_> Obstacle_Seq;
            typedef DDS_DCPSSequence_var < Obstacle_Seq> Obstacle_Seq_var;
            typedef DDS_DCPSSequence_out < Obstacle_Seq> Obstacle_Seq_out;

            class  Obstacle_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Obstacle_TypeSupportInterface_ptr _ptr_type;
                typedef Obstacle_TypeSupportInterface_var _var_type;

                static Obstacle_TypeSupportInterface_ptr _duplicate (Obstacle_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Obstacle_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Obstacle_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Obstacle_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Obstacle_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Obstacle_TypeSupportInterface () {};
                ~Obstacle_TypeSupportInterface () {};
            private:
                Obstacle_TypeSupportInterface (const Obstacle_TypeSupportInterface &);
                Obstacle_TypeSupportInterface & operator = (const Obstacle_TypeSupportInterface &);
            };

            class  Obstacle_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Obstacle_DataWriter_ptr _ptr_type;
                typedef Obstacle_DataWriter_var _var_type;

                static Obstacle_DataWriter_ptr _duplicate (Obstacle_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Obstacle_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Obstacle_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Obstacle_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Obstacle_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Obstacle_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Obstacle_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Obstacle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Obstacle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Obstacle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Obstacle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Obstacle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Obstacle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Obstacle_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Obstacle_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Obstacle_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Obstacle_& instance_data) = 0;

            protected:
                Obstacle_DataWriter () {};
                ~Obstacle_DataWriter () {};
            private:
                Obstacle_DataWriter (const Obstacle_DataWriter &);
                Obstacle_DataWriter & operator = (const Obstacle_DataWriter &);
            };

            class  Obstacle_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Obstacle_DataReader_ptr _ptr_type;
                typedef Obstacle_DataReader_var _var_type;

                static Obstacle_DataReader_ptr _duplicate (Obstacle_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Obstacle_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Obstacle_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Obstacle_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Obstacle_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Obstacle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Obstacle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Obstacle_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Obstacle_& instance) = 0;

            protected:
                Obstacle_DataReader () {};
                ~Obstacle_DataReader () {};
            private:
                Obstacle_DataReader (const Obstacle_DataReader &);
                Obstacle_DataReader & operator = (const Obstacle_DataReader &);
            };

            class  Obstacle_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Obstacle_DataReaderView_ptr _ptr_type;
                typedef Obstacle_DataReaderView_var _var_type;

                static Obstacle_DataReaderView_ptr _duplicate (Obstacle_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Obstacle_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Obstacle_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Obstacle_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Obstacle_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Obstacle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Obstacle_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Obstacle_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Obstacle_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Obstacle_& instance) = 0;

            protected:
                Obstacle_DataReaderView () {};
                ~Obstacle_DataReaderView () {};
            private:
                Obstacle_DataReaderView (const Obstacle_DataReaderView &);
                Obstacle_DataReaderView & operator = (const Obstacle_DataReaderView &);
            };
        }

    }

}

#endif
