#ifndef _H_814DE55E6062093E351311D7FAA5C4D5_PathPlanning_DCPS_H_
#define _H_814DE55E6062093E351311D7FAA5C4D5_PathPlanning_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PathPlanning_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PathPlanning_TypeSupportInterface;

            typedef PathPlanning_TypeSupportInterface * PathPlanning_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PathPlanning_TypeSupportInterface> PathPlanning_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PathPlanning_TypeSupportInterface> PathPlanning_TypeSupportInterface_out;


            class PathPlanning_DataWriter;

            typedef PathPlanning_DataWriter * PathPlanning_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PathPlanning_DataWriter> PathPlanning_DataWriter_var;
            typedef DDS_DCPSInterface_out < PathPlanning_DataWriter> PathPlanning_DataWriter_out;


            class PathPlanning_DataReader;

            typedef PathPlanning_DataReader * PathPlanning_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PathPlanning_DataReader> PathPlanning_DataReader_var;
            typedef DDS_DCPSInterface_out < PathPlanning_DataReader> PathPlanning_DataReader_out;


            class PathPlanning_DataReaderView;

            typedef PathPlanning_DataReaderView * PathPlanning_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PathPlanning_DataReaderView> PathPlanning_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PathPlanning_DataReaderView> PathPlanning_DataReaderView_out;

            struct PathPlanning_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PathPlanning_, struct PathPlanning_Seq_uniq_> PathPlanning_Seq;
            typedef DDS_DCPSSequence_var < PathPlanning_Seq> PathPlanning_Seq_var;
            typedef DDS_DCPSSequence_out < PathPlanning_Seq> PathPlanning_Seq_out;

            class  PathPlanning_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PathPlanning_TypeSupportInterface_ptr _ptr_type;
                typedef PathPlanning_TypeSupportInterface_var _var_type;

                static PathPlanning_TypeSupportInterface_ptr _duplicate (PathPlanning_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PathPlanning_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PathPlanning_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PathPlanning_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PathPlanning_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PathPlanning_TypeSupportInterface () {};
                ~PathPlanning_TypeSupportInterface () {};
            private:
                PathPlanning_TypeSupportInterface (const PathPlanning_TypeSupportInterface &);
                PathPlanning_TypeSupportInterface & operator = (const PathPlanning_TypeSupportInterface &);
            };

            class  PathPlanning_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PathPlanning_DataWriter_ptr _ptr_type;
                typedef PathPlanning_DataWriter_var _var_type;

                static PathPlanning_DataWriter_ptr _duplicate (PathPlanning_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PathPlanning_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PathPlanning_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PathPlanning_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PathPlanning_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PathPlanning_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PathPlanning_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PathPlanning_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PathPlanning_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PathPlanning_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PathPlanning_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PathPlanning_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PathPlanning_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PathPlanning_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PathPlanning_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PathPlanning_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PathPlanning_& instance_data) = 0;

            protected:
                PathPlanning_DataWriter () {};
                ~PathPlanning_DataWriter () {};
            private:
                PathPlanning_DataWriter (const PathPlanning_DataWriter &);
                PathPlanning_DataWriter & operator = (const PathPlanning_DataWriter &);
            };

            class  PathPlanning_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PathPlanning_DataReader_ptr _ptr_type;
                typedef PathPlanning_DataReader_var _var_type;

                static PathPlanning_DataReader_ptr _duplicate (PathPlanning_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PathPlanning_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PathPlanning_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PathPlanning_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PathPlanning_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PathPlanning_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PathPlanning_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PathPlanning_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PathPlanning_& instance) = 0;

            protected:
                PathPlanning_DataReader () {};
                ~PathPlanning_DataReader () {};
            private:
                PathPlanning_DataReader (const PathPlanning_DataReader &);
                PathPlanning_DataReader & operator = (const PathPlanning_DataReader &);
            };

            class  PathPlanning_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PathPlanning_DataReaderView_ptr _ptr_type;
                typedef PathPlanning_DataReaderView_var _var_type;

                static PathPlanning_DataReaderView_ptr _duplicate (PathPlanning_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PathPlanning_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PathPlanning_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PathPlanning_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PathPlanning_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PathPlanning_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PathPlanning_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PathPlanning_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PathPlanning_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PathPlanning_& instance) = 0;

            protected:
                PathPlanning_DataReaderView () {};
                ~PathPlanning_DataReaderView () {};
            private:
                PathPlanning_DataReaderView (const PathPlanning_DataReaderView &);
                PathPlanning_DataReaderView & operator = (const PathPlanning_DataReaderView &);
            };
        }

    }

}

#endif
