#ifndef _H_27660E7425117F2E3E3FFA192417D03F_RouteArray_DCPS_H_
#define _H_27660E7425117F2E3E3FFA192417D03F_RouteArray_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RouteArray_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RouteArray_TypeSupportInterface;

            typedef RouteArray_TypeSupportInterface * RouteArray_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RouteArray_TypeSupportInterface> RouteArray_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RouteArray_TypeSupportInterface> RouteArray_TypeSupportInterface_out;


            class RouteArray_DataWriter;

            typedef RouteArray_DataWriter * RouteArray_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RouteArray_DataWriter> RouteArray_DataWriter_var;
            typedef DDS_DCPSInterface_out < RouteArray_DataWriter> RouteArray_DataWriter_out;


            class RouteArray_DataReader;

            typedef RouteArray_DataReader * RouteArray_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RouteArray_DataReader> RouteArray_DataReader_var;
            typedef DDS_DCPSInterface_out < RouteArray_DataReader> RouteArray_DataReader_out;


            class RouteArray_DataReaderView;

            typedef RouteArray_DataReaderView * RouteArray_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RouteArray_DataReaderView> RouteArray_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RouteArray_DataReaderView> RouteArray_DataReaderView_out;

            struct RouteArray_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < RouteArray_, struct RouteArray_Seq_uniq_> RouteArray_Seq;
            typedef DDS_DCPSSequence_var < RouteArray_Seq> RouteArray_Seq_var;
            typedef DDS_DCPSSequence_out < RouteArray_Seq> RouteArray_Seq_out;

            class  RouteArray_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RouteArray_TypeSupportInterface_ptr _ptr_type;
                typedef RouteArray_TypeSupportInterface_var _var_type;

                static RouteArray_TypeSupportInterface_ptr _duplicate (RouteArray_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RouteArray_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RouteArray_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RouteArray_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RouteArray_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RouteArray_TypeSupportInterface () {};
                ~RouteArray_TypeSupportInterface () {};
            private:
                RouteArray_TypeSupportInterface (const RouteArray_TypeSupportInterface &);
                RouteArray_TypeSupportInterface & operator = (const RouteArray_TypeSupportInterface &);
            };

            class  RouteArray_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RouteArray_DataWriter_ptr _ptr_type;
                typedef RouteArray_DataWriter_var _var_type;

                static RouteArray_DataWriter_ptr _duplicate (RouteArray_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RouteArray_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RouteArray_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RouteArray_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RouteArray_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RouteArray_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RouteArray_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RouteArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RouteArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RouteArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RouteArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RouteArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RouteArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RouteArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RouteArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RouteArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RouteArray_& instance_data) = 0;

            protected:
                RouteArray_DataWriter () {};
                ~RouteArray_DataWriter () {};
            private:
                RouteArray_DataWriter (const RouteArray_DataWriter &);
                RouteArray_DataWriter & operator = (const RouteArray_DataWriter &);
            };

            class  RouteArray_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RouteArray_DataReader_ptr _ptr_type;
                typedef RouteArray_DataReader_var _var_type;

                static RouteArray_DataReader_ptr _duplicate (RouteArray_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RouteArray_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RouteArray_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RouteArray_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RouteArray_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RouteArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RouteArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RouteArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RouteArray_& instance) = 0;

            protected:
                RouteArray_DataReader () {};
                ~RouteArray_DataReader () {};
            private:
                RouteArray_DataReader (const RouteArray_DataReader &);
                RouteArray_DataReader & operator = (const RouteArray_DataReader &);
            };

            class  RouteArray_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RouteArray_DataReaderView_ptr _ptr_type;
                typedef RouteArray_DataReaderView_var _var_type;

                static RouteArray_DataReaderView_ptr _duplicate (RouteArray_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RouteArray_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RouteArray_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RouteArray_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RouteArray_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RouteArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RouteArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RouteArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RouteArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RouteArray_& instance) = 0;

            protected:
                RouteArray_DataReaderView () {};
                ~RouteArray_DataReaderView () {};
            private:
                RouteArray_DataReaderView (const RouteArray_DataReaderView &);
                RouteArray_DataReaderView & operator = (const RouteArray_DataReaderView &);
            };
        }

    }

}

#endif
