#ifndef _H_787A2461AD87301E6F57CEA246EDBF24_Route_DCPS_H_
#define _H_787A2461AD87301E6F57CEA246EDBF24_Route_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Route_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Route_TypeSupportInterface;

            typedef Route_TypeSupportInterface * Route_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Route_TypeSupportInterface> Route_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Route_TypeSupportInterface> Route_TypeSupportInterface_out;


            class Route_DataWriter;

            typedef Route_DataWriter * Route_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Route_DataWriter> Route_DataWriter_var;
            typedef DDS_DCPSInterface_out < Route_DataWriter> Route_DataWriter_out;


            class Route_DataReader;

            typedef Route_DataReader * Route_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Route_DataReader> Route_DataReader_var;
            typedef DDS_DCPSInterface_out < Route_DataReader> Route_DataReader_out;


            class Route_DataReaderView;

            typedef Route_DataReaderView * Route_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Route_DataReaderView> Route_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Route_DataReaderView> Route_DataReaderView_out;

            struct Route_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Route_, struct Route_Seq_uniq_> Route_Seq;
            typedef DDS_DCPSSequence_var < Route_Seq> Route_Seq_var;
            typedef DDS_DCPSSequence_out < Route_Seq> Route_Seq_out;

            class  Route_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Route_TypeSupportInterface_ptr _ptr_type;
                typedef Route_TypeSupportInterface_var _var_type;

                static Route_TypeSupportInterface_ptr _duplicate (Route_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Route_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Route_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Route_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Route_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Route_TypeSupportInterface () {};
                ~Route_TypeSupportInterface () {};
            private:
                Route_TypeSupportInterface (const Route_TypeSupportInterface &);
                Route_TypeSupportInterface & operator = (const Route_TypeSupportInterface &);
            };

            class  Route_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Route_DataWriter_ptr _ptr_type;
                typedef Route_DataWriter_var _var_type;

                static Route_DataWriter_ptr _duplicate (Route_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Route_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Route_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Route_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Route_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Route_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Route_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Route_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Route_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Route_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Route_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Route_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Route_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Route_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Route_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Route_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Route_& instance_data) = 0;

            protected:
                Route_DataWriter () {};
                ~Route_DataWriter () {};
            private:
                Route_DataWriter (const Route_DataWriter &);
                Route_DataWriter & operator = (const Route_DataWriter &);
            };

            class  Route_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Route_DataReader_ptr _ptr_type;
                typedef Route_DataReader_var _var_type;

                static Route_DataReader_ptr _duplicate (Route_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Route_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Route_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Route_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Route_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Route_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Route_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Route_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Route_& instance) = 0;

            protected:
                Route_DataReader () {};
                ~Route_DataReader () {};
            private:
                Route_DataReader (const Route_DataReader &);
                Route_DataReader & operator = (const Route_DataReader &);
            };

            class  Route_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Route_DataReaderView_ptr _ptr_type;
                typedef Route_DataReaderView_var _var_type;

                static Route_DataReaderView_ptr _duplicate (Route_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Route_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Route_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Route_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Route_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Route_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Route_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Route_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Route_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Route_& instance) = 0;

            protected:
                Route_DataReaderView () {};
                ~Route_DataReaderView () {};
            private:
                Route_DataReaderView (const Route_DataReaderView &);
                Route_DataReaderView & operator = (const Route_DataReaderView &);
            };
        }

    }

}

#endif
