#ifndef _H_9BCAAB5DAFB991814FDA692A58A31007_TrackedObject__H_
#define _H_9BCAAB5DAFB991814FDA692A58A31007_TrackedObject__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "geometry_msgs/msg/dds_opensplice/PoseWithCovariance_.h"
#include "geometry_msgs/msg/dds_opensplice/TwistWithCovariance_.h"
#include "geometry_msgs/msg/dds_opensplice/Vector3_.h"
#include "geometry_msgs/msg/dds_opensplice/Point_.h"
#include "builtin_interfaces/msg/dds_opensplice/Duration_.h"


namespace marti_nav_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace TrackedObject_Constants
            {
                const ::DDS::Octet VEHICLE_ = 0;

                const ::DDS::Octet PEDESTRIAN_ = 1;

                const ::DDS::Octet UNKNOWN_ = 255;

            }

            struct  TrackedObject_
            {
                struct _linear_acceleration_covariance__uniq_{};
                typedef ::DDS::Double _linear_acceleration_covariance__slice;
                typedef ::DDS::Double _linear_acceleration_covariance_[9];
                typedef DDS_DCPS_FArray_var< _linear_acceleration_covariance_, _linear_acceleration_covariance__slice, struct _linear_acceleration_covariance__uniq_ > _linear_acceleration_covariance__var;
                typedef _linear_acceleration_covariance_ _linear_acceleration_covariance__out;
                typedef DDS_DCPS_Array_forany< _linear_acceleration_covariance_, _linear_acceleration_covariance__slice, struct _linear_acceleration_covariance__uniq_ > _linear_acceleration_covariance__forany;
                static _linear_acceleration_covariance__slice *_linear_acceleration_covariance__alloc();
                static void _linear_acceleration_covariance__free(_linear_acceleration_covariance__slice *);
                static void _linear_acceleration_covariance__copy(_linear_acceleration_covariance__slice *to, const _linear_acceleration_covariance__slice *from);
                static _linear_acceleration_covariance__slice *_linear_acceleration_covariance__dup(const _linear_acceleration_covariance__slice *from);
                struct _polygon__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::geometry_msgs::msg::dds_::Point_, struct _polygon__seq_uniq_ > _polygon__seq;
                typedef DDS_DCPSSequence_var< _polygon__seq > _polygon__seq_var;
                typedef DDS_DCPSSequence_out< _polygon__seq > _polygon__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::UShort id_;
                ::geometry_msgs::msg::dds_::PoseWithCovariance_ pose_;
                ::geometry_msgs::msg::dds_::TwistWithCovariance_ velocity_;
                ::geometry_msgs::msg::dds_::Vector3_ linear_acceleration_;
                _linear_acceleration_covariance_ linear_acceleration_covariance_;
                _polygon__seq polygon_;
                ::DDS::Float length_;
                ::DDS::Float length_quality_;
                ::DDS::Float width_;
                ::DDS::Float width_quality_;
                ::DDS::Octet classification_;
                ::DDS::Float classification_quality_;
                ::DDS::Float existence_probability_;
                ::builtin_interfaces::msg::dds_::Duration_ age_duration_;
                ::builtin_interfaces::msg::dds_::Duration_ prediction_duration_;
                ::DDS::Boolean active_;
            };

            typedef DDS_DCPSStruct_var<TrackedObject_> TrackedObject__var;
            typedef DDS_DCPSStruct_out < TrackedObject_> TrackedObject__out;

        }

    }

}

#endif /* _H_9BCAAB5DAFB991814FDA692A58A31007_TrackedObject__H_ */
